#include <os.h>

int main(int argc, char **argv)
{
	FILE *from, *to;
	char ch;


	if(argc != 3)
	{
		printf("USAGE: %s SOURCE DESTINATION\n",argv[0]);
		printf("Copies a file from SOURCE to DESTINATION.\n");
		return 0;
	}
	
	// Open source file
	from = fopen(argv[1], "rb");
	if(!from)
	{
		printf("Error opening source file: %s\n",strerror(errno));
		return 0;
	}
	
	// Open dest file
	to = fopen(argv[2], "wb");
	if(!to)
	{
		printf("Error opening destination file: %s\n",strerror(errno));
		return 0;
	}
	
	// Copy file
	while(!feof(from))
	{
		ch = fgetc(from);
		if(ferror(from))
		{
			printf("Error reading source file.\n");
			return 0;
		}
		if(!feof(from)) fputc(ch, to);
		if(ferror(to))
		{
			printf("Error writing destination file.\n");
			return 0;
		}
	}

	if(fclose(from)==EOF)
	{
		printf("Error closing source file.\n");
		return 0;
	}

	if(fclose(to)==EOF)
	{
		printf("Error closing destination file.\n");
		return 0;
	}

	return 0;
}