#include <os.h>

#define BINDIR "\\documents\\bin\\"
#define PRGMSIG "PRG"

char *my_strtok(char *string, const char *separator)
{
    char *s1, *s2;
    static char *str_save;
	
    if (string == NULL)
	{
        string = str_save;
        if (string == NULL) return (char *)NULL;
    }
    s1 = string + strspn(string, separator);
    if (*s1 == '\0')
	{
        str_save = NULL;
        return (char *)NULL;
    }
    s2 = strpbrk(s1, separator);
    if (s2 != NULL)
	{
        *s2++ = '\0';
	}
    str_save = s2;

    return s1;
}

int main(int argc, char** argv)
{
	// Disable interrupts for RS232 communication
	unsigned intmask = TCT_Local_Control_Interrupts(0);
	char path[100];
	char path2[100];
	char buf[100];
	char* n_argv[20];
	int n_argc;
	
	while(1)
	{
		// Always read current dir
		NU_Current_Dir("A:",path);
		printf("A:%s>",path);
		
		fflush(stdin);
		fgets(buf,100,stdin);
		
		// Making C's argc and argv ready
		n_argc = 0;
		n_argv[0] = my_strtok(buf," \r\n");

		while(n_argv[n_argc] != NULL)
		{
			n_argv[++n_argc] = my_strtok(NULL," \r\n");
		}
		
		// Checking for rshell commands
		if(strcmp(n_argv[0],"cd") == 0)
		{
			// Command: Change directory
			if(chdir(n_argv[1]) != 0)
			{
				printf("Error: %s\n",strerror(errno));
			}
			continue;
		}
		if(strcmp(n_argv[0],"exit") == 0)
		{
			// Command: Exit rshell
			break;
		}
		
		
		// Search file
		struct stat fstat;
		// Check for absolute path
		if(stat(n_argv[0],&fstat) != 0)
		{
			// Check in current path
			strcpy(path2,path);
			strcat(path2,n_argv[0]);
			if(stat(path2,&fstat) != 0)
			{
				// Check in BINDIR
				strcpy(path2,BINDIR);
				strcat(path2,n_argv[0]);
				if(stat(path2,&fstat) != 0)
				{
					printf("Error: %s\n",strerror(errno));
					continue;
				}
			}
		}
		else
		{
			strcpy(path2,n_argv[0]);
		}
		
		// Open file, ...
		FILE *docfile = fopen(path2,"rb");
		if(!docfile)
		{
			printf("Error: %s\n",strerror(errno));
			continue;
		}

		// ...allocate memory for file, ...
		void *docptr = malloc(fstat.st_size);
		if(!docptr)
		{
			printf("Error: %s\n",strerror(errno));
			continue;
		}

		// ...read file into memory...
		if(!fread(docptr,fstat.st_size,1,docfile))
		{
			printf("Error: %s\n",strerror(errno));
			continue;
		}

		if(strcmp(PRGMSIG,docptr))
		{
			printf("Error: File is not executable\n");
			fclose(docfile);
			free(docptr);			
			continue;
		}

		if(fclose(docfile) == EOF)
		{
			printf("Error: %s\n",strerror(errno));
			continue;
		}

		// and launch it!
		((void (*)(int, char **))(docptr + sizeof(PRGMSIG)))(n_argc, n_argv);
		
		// Clean up...
		free(docptr);
		
		
		// ...and do it all again.
	}
	
	// Restore interupts
	TCT_Local_Control_Interrupts(intmask);
	return 0;
}